"""
Test Python-Pari
"""

from py_pari import *
def foo0():	"""
py_pari.pyx
"""

def foo1():	"""
    Initialize the PARI system.
    
    INPUT:
        size -- long, the number of bytes given to PARI to work with
                (default: 100 000 000)
        maxprime -- unsigned long, upper limit on a precomputed prime
                    number table  (default: 50000)
    
    If you do not want prime numbers, put maxprime=2, but be careful
    because many PARI functions require this table.  If you get the
    error message "not enough precomputed primes", increase this
    parameter.
    """

def foo2():	"""
        isprime(x, flag=0)
        Returns true (1) if x is a PROVEN prime number, and false (0)
        otherwise. 

        INPUT:
            flag -- int 
                    0 (default): use a combination of algorithms.
                    1: certify primality using the Pocklington-Lehmer Test.
                    2: certify primality using the APRCL test.
        OUTPUT:
            gen -- 0 or 1
        """

def foo3():	"""
        elladd(self, z1, z2):

        Sum of the points z1 and z2 on the elliptic curve self.

        INPUT:
            self -- elliptic curve E
            z1 -- point on E
            z2 -- point on E
            
        OUTPUT:
            point on E

        EXAMPLES:
            >>> e = pari("ellinit([0, 1, 1, -2, 0])")
            >>> z1 = pari("[1,0,1]")
            >>> z2 = pari("[-1,1,1]")
            >>> e.elladd(z1, z2)
            [-3/4, -15/8]
        """

def foo4():	"""
        """

def foo5():	"""
        ellchangepoint(x,y)

        change data on point or vector of points x on an elliptic curve according
        to y=[u,r,s,t]
        """

def foo6():	"""
        ellheightmatrix(e,x)

        Returns the height matrix for vector of points x on elliptic curve e using
        theta functions.
        """

def foo7():	"""
        ellinit(x,{flag=0}): x being the vector [a1,a2,a3,a4,a6], gives
        the vector: [a1,a2,a3,a4,a6,
                    b2,b4,b6,b8,
                    c4,c6,
                    delta,j,
                    [e1,e2,e3],
                    w1,w2,eta1,eta2,area].
        If the curve is defined over a p-adic field, the last six components
        are replaced by root,u^2,u,q,w,0. If optional flag is 1, omit them
        altogether.
        """


if __name__ ==  '__main__':
    import doctest, sys
    doctest.testmod(sys.modules[__name__])
