
print """
**********************************************************
*  SAGE Version 0.2                                      *
*  System for Arithmetic Geometry Experimentation        *
*  (c) William Stein, 2005                               *
*  http://modular.fas.harvard.edu/SAGE                   *
*  Distributed under the terms of the GPL                *
**********************************************************
Help: object? -> Documentation about 'object'.
"""


import sage.misc.interpreter
from sage.rings.rings import *

#from sage.linalg.linalg import *
from sage.linalg.matrix import *
from sage.linalg.matrix_space import *
from sage.linalg.vector import *
from sage.linalg.vector_space import *
from sage.misc.misc import *
from sage.modular.modsym.modsym import *
from sage.modular.modsym.heilbronn import *
from sage.modular.modform.modform import *
from sage.modular.abvar.modabvar import *
from sage.rings.rings import *
from sage.rings.arith import *
from sage.rings.integer_ring import factor
from math import *
import sage.tables.cremona as cremona
import sage.tables.odlyzko as odlyzko
from sage.ellcurve.ellcurve import *
from sage.modular.dirichlet import *
from sage.modular.congroup import *
from sage.functions.transcendental import zeta
from sage.groups.abelian import *
import sage.pari.py_pari as pari


from os import system

# maximize memory resources
try:
    import resource   # unix only...
    resource.setrlimit(resource.RLIMIT_AS, (-1,-1))
except:
    pass

# shortcuts
VS=VectorSpace
MS=ModularSymbols
MF=ModularForms
EC=EllipticCurve
NF=NumberField

def CS(x):
    return x.cuspidal_subspace()
def NS(x):
    return x.new_subspace()
def OS(x):
    return x.old_subspace()
def ES(x):
    return x.eisenstein_subspace()
def NCMS(n,k=2,sign=1):
    return ms(n,weight=k,sign=sign).cuspidal_subspace().new_subspace()

quo=rings.Rational
tm=misc.cputime

Q = rings.RationalField()
Z = rings.IntegerRing()
R = rings.RealField()
C = rings.ComplexField()
I = C.gen(0); i = C.gen(0)

def rprint(x):
    for z in x:
        print z

def pr(x):
    for z in x:
        print z

##############################################################################
# There are many functions on elements of a ring, which mathematicians
# usually write f(x), e.g., it is weird to write x.log() and natural
# to write log(x).  The functions below allow for the more familiar syntax.
##############################################################################
def arg(x): return x.arg()

def base_ring(x): return x.base_ring()

def basis(x): return x.basis()

def charpoly(x): return x.charpoly()

def decomposition(x): return x.decomposition()

def det(x): return x.det()

def exp(x):
    try: return x.exp()
    except AttributeError: return math.exp(x)

def gens(x): return x.gens()

def hecke_operator(x,n): return x.hecke_operator(n)

def image(x): return x.image()

def kernel(x): return x.kernel()

def log(x):
    try: return x.log()
    except AttributeError: return math.log(x)

def ngens(x): return x.ngens()

def order(x): return x.order()

def parent(x): return x.parent()

def norm(x): return x.norm()


##########################################################################
# I tried this save/restore session, but it seems hopeless.
# For example, how to restore the local caches of modular symbols
# spaces and vector spaces to the modules?  It's probably better
# to have an object-by-object database anyways.

# def save_session(dirname):
#     """
#     Save the current session to the named directory.  A file is
#     created for each object currently defined.
#     """
#     if os.path.exists(dirname):
#         os.rename(dirname,dirname+".old")
#     os.mkdir(dirname)
#     for x in show_identifiers():
#         db.save(globals()[x], "%s/%s"%(dirname,x))

# import posix
# def load_session(dirname):
#     """
#     Load all variables defined in a session from the named directory.
#     """
#     assert os.path.exists(dirname), "Directory %s does not exist."%dirname
#     for x in posix.listdir(dirname):
#         globals()[x] = db.load("%s/%s"%(dirname,x))

        
iglob = globals().keys()[:] + \
        ['os', '__', '_i1', '_i', '_ii', '___', 'show_identifiers', '_iii', '_', 'iglob']
def show_identifiers():
    """
    Returns a list of the names of non-hidden (i.e., not starting with
    an underscore) identifiers defined by the user in this session.
    These are the identifiers saved by the save command.
    """
    return [k for k in globals().keys() if not k in iglob and k[0] != "_"]


